#include "stdafx.h";
#include<iostream>
using namespace std;

const int N=4;
bool simmetricaDP(int matr[][N], int i, int j){
  //fine della ricorsione
  if (i==0) return true;

  // fine esame di una riga: si passa alla riga di indice inferiore
  if (j<0) return (simmetricaDP(matr, i-1, i-1));

  // elemento sulla diagonale principale: si passa alla colonna di indice inferiore
  if (i==j) return (simmetricaDP(matr, i, j-1));

  // elemento della triangolare inferiore da confrontare col simmetrico della triangolare superiore
  return (matr[i][j]==matr[j][i]) && (simmetricaDP(matr, i, j-1));
}

bool simmetricaDS(int matr[][N], int i, int j){
  //fine della ricorsione
  if (i==0) return true;

  // fine esame di una riga: si passa alla riga di indice inferiore
  //if (i+j==N-1) return (simmetricaDS(matr, i-1, 0));

  // elemento sulla diagonale secondaria: si passa alla alla riga di indice inferiore
  if (i+j==N-1) return (simmetricaDS(matr, i-1, N-1));

  // elemento della triangolare inferiore da confrontare col simmetrico della triangolare superiore
  return (matr[i][j]==matr[N-j-1][N-i-1]) && (simmetricaDS(matr, i, j-1));
} 

void main(void){
        int alfa[N][N], i,j;

	for(i = 0; i < N; i++)
		for(j = 0; j < N; j++){
			cout<<"Inserisci alfa["<<i<<"]["<<j<<"]: ";
			cin>>alfa[i][j];
		} 
	
	for(i = 0; i < N; i++){
		for(j = 0; j < N; j++)
			cout<<alfa[i][j]<<'\t';
		cout<<endl;
	} 
	if(simmetricaDP(alfa,N-1,N-1))
	 cout<<"Matrice simmetrica rispetto alla diagonale principale"<<endl;
	else
	 cout<<"Matrice non simmetrica rispetto alla diagonale principale"<<endl;

	if(simmetricaDS(alfa,N-1,N-1))
	 cout<<"Matrice simmetrica rispetto alla diagonale secondaria"<<endl;
	else
	 cout<<"Matrice non simmetrica rispetto alla diagonale secondaria"<<endl;
 
}



