#include "stdafx.h";
#include<time.h>
#include<iostream>

using namespace std;

void quickSort(int v[], int inf, int sup){
 int s, i, p, t;

 if (inf < sup){
  i = inf;
  s = sup;
  p = v[sup];
  do {
      while (i<s && v[i]<=p)
        i++;
      while (s>i && v[s]>=p)
        s--;
      if (i < s){
          t = v[i];
          v[i] = v[s];
          v[s] = t;
      }
  } while (i<s);
  t = v[i];
  v[i] = v[sup];
  v[sup] = t;
  quickSort(v, inf, i-1); // ricorsione sull'insieme sinistro
  quickSort(v, i+1, sup); // ricorsione sull'insieme destro
 }
}


void main(void){
 int V[100], i,N;

 cout<<"Inserisci numero elementi vettore (max 100): ";
			cin>>N;
	for(i = 0; i < N; i++)
		V[i]=rand()%50; // caricamento random del vettore valori tra 0 e 50
	
	cout<<endl<<"Vettore generato"<<endl;
	for(i = 0; i < N; i++)
			cout<<V[i]<<"  ";


	quickSort(V, 0, N-1);
	cout<<endl<<"Vettore ordinato"<<endl;
	for(i = 0; i < N; i++)
			cout<<V[i]<<"  ";
	cout<<endl;
 
}


