#include "stdafx.h";
#include<iostream>

using namespace std;

const int N = 4; // numero di dischi

// visualizza la matrice
void visualizza(int torre[][3]){
 int i,j;
 char c;
 cout<<endl;
 for (i=0; i<N; i++){
  for (j=0; j<3; j++)
   cout<<torre[i][j]<<'\t';
  cout<<endl;
 }
 cout<<"Digitare un carattere per continuare ";
 cin>>c; // attesa input utente per avanzamento
}

// determina la posizione del disco da spostare
int posizioneDisco(int torre[][3], int piolo){
  int i;
  for (i=0; i<N; i++)
   if (torre[i][piolo] != 0)
    return i;
  return i;
}
// determina la destinazione del disco da spostare
int destinazioneDisco(int torre[][3], int piolo){
  int i;
  for (i=N-1; i>=0; i--)
   if (torre[i][piolo] == 0)
    return i;
  return i;
}

// funzione ricorsiva
void hanoi(int torre[][3], int n, int p1, int p2){
  int disco, posizione, destinazione;
  if (n>0){
   hanoi(torre, n-1, p1, 6-p1-p2); // invocazione ricorsiva
   visualizza(torre);
   cout<<endl<<"disco "<<n<<" da piolo "<<p1<<" a piolo "<<p2<<endl;
   posizione = posizioneDisco(torre, p1-1);
   disco = torre[posizione][p1-1];
   torre[posizione][p1-1] = 0; // rimozione disco
   destinazione = destinazioneDisco(torre, p2-1);
   torre[destinazione][p2-1] = disco; // posizionamento disco
   hanoi(torre, n-1, 6-p1-p2, p2); // invocazione ricorsiva
 }
}
void main(void){
 int torre[N][3] = {0};
 // posiziona N dischi sul piolo 1
 for (int i=0; i<N; i++)
  torre[i][0] = i+1;
 hanoi(torre, N, 1, 3); // sposta N dischi dal piolo 1 al piolo 3
 visualizza(torre);
}



